
;;SapphirePalace - Videogame
;;
   ;; Copyright (C) 2022 Jorge Lizón Perea, Angelica Quaranta Barba, Joan Pascual Izquierdo.
;;
   ;; This program is free software: you can redistribute it and/or modify
   ;; it under the terms of the GNU General Public License as published by
   ;; the Free Software Foundation, either version 3 of the License, or
   ;; (at your option) any later version.
;;
   ;; This program is distributed in the hope that it will be useful,
   ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
   ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ;; GNU General Public License for more details.
;;
   ;; You should have received a copy of the GNU General Public License
   ;; along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "cpctelera.h.s"
.include "man/entities.inc"
.include "sys/physics.inc"
.include "sys/input.inc"
.include "sys/render.inc"
.include "sys/colisions.inc"
.include "music/tensionsacaV2-5.h.s"
.include "man/animations.inc"
.area _DATA
.area _CODE

;; 
;; Declare all function entry points as global symbols for the compiler.
;; (The linker will know what to do with them)
;; WARNING: Every global symbol declared will be linked, so DO NOT declare 
;; symbols for functions you do not use.
;;
.globl cpct_disableFirmware_asm
.globl cpct_setDrawCharM1_asm
.globl cpct_drawSolidBox_asm
.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl cpct_isAnyKeyPressed_asm
.globl cpct_waitVSYNC_asm
.globl cpct_akp_musicInit_asm
.globl cpct_akp_musicPlay_asm

.globl render_init
.globl render_tilemap_uno
.globl render_pinta_fantasma
.globl sys_colision_update
.globl tile_draw_inicio

.globl _fantasma_array
.globl _song_menu
.globl _song_tension

cont: .db #70

;DefineEntity entity,Type, e_x, e_y, size_x, size_y, e_vx, e_vy, vida, (e_prevx), (e_prevy)
 ;DefineEntity player,  1 ,  7 , 75 ,   4   ,  8   ,  0  ,  0  ,  3 ;,     3    ,     40   
;DefineEntity enemy1,Type, e_x, e_y, size_x, size_y, e_vx, e_vy, vida, (e_prevx), (e_prevy)
 ;;DefineEntity enemy1,  2 ,  25 , 75 ,   4   ,  8   ,  1  ,  1  ,  1
 ;;DefineEntity enemy2,  4 ,  65 , 60 ,   8   ,  16   ,  1  ,  0  ,  1
 ;DefineEntity puerta1  3  , 68 , 80 ,   4   ,  16   ,  0  ,  0  ,  1

 ;DefineEntity enemy2  2  , 70 , 80 ,   4   ,  16   ,  0  ,  0  ,  1

;;
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm
   
   ;; Initialize things

   call man_entity_init
   call render_init
   ;ld de, #_song_menu
   ;call cpct_akp_musicInit_asm
   ;call tile_draw_inicio
   ld de, #_song_tension
   call cpct_akp_musicInit_asm
   cpctm_setBorder_asm HW_BLUE   

   call loopesito_comienza_menu
   ;loopecito_menu:
   ;   ;call cpct_akp_musicPlay_asm
   ;   call cpct_scanKeyboard_f_asm
   ;   jr z, loopecito_menu
   ;      ld hl, #Key_Space
   ;      call cpct_isKeyPressed_asm
   ;   jr z, loopecito_menu
   ;; creating lv1 entities

   ;ld hl,#player
   ;call man_entity_create
   

  ;; ld hl,#enemy1
   ;;call man_entity_create

   ;;ld hl,#enemy2
   ;;call man_entity_create

   

   ;ld hl, #puerta1
   ;call man_entity_create

  
   ;call render_tilemap_uno ;;FUERA DEL LOOP EL PUNYETERO MAPA
   
loop:
   
   call cpct_waitVSYNC_asm
   call cpct_akp_musicPlay_asm
   
   call sys_render_update
   call sys_input_update
   call sys_physics_update
   call sys_colision_update

   ;
   ;;Animation change
   ;

   ld a, (cont)
   dec a
   ld (cont), a
   or #0
   jr nz, loop
   call update_animation
   ld a, #70
   ld (cont), a
jr loop