
;;SapphirePalace - Videogame
;;
   ;; Copyright (C) 2022 Jorge Lizón Perea, Angelica Quaranta Barba, Joan Pascual Izquierdo.
;;
   ;; This program is free software: you can redistribute it and/or modify
   ;; it under the terms of the GNU General Public License as published by
   ;; the Free Software Foundation, either version 3 of the License, or
   ;; (at your option) any later version.
;;
   ;; This program is distributed in the hope that it will be useful,
   ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
   ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ;; GNU General Public License for more details.
;;
   ;; You should have received a copy of the GNU General Public License
   ;; along with this program.  If not, see <https://www.gnu.org/licenses/>.
.module Entity_Manager

.area _CODE

.include "entities.inc"
.include "cpctelera.h.s" ;;los loop con nombre diferente

entities_storage_size = max_entities * sizeof_e +1 ;;con un byte extra al final


;; Almacen de entidades
entities::

;;creamos el array usando el primer bit para nuestras cosas

;;db 1byte, dw 2 bytes, ds cualquiera

;;EJ: con e_size = 1
;; 5000 |00|00|00|00|00|00|00|00
;; 5000 |02|50|00|00|00|00|00|00
;; 5002 = HL , le sumamos el e_eize = 5003
;; 5002 = DE
;; 5000 |03|50|FF|00|00|00|00|00
;;num_entities:: .db 0

entities_1st_free: .dw entities_storage ;;puntero al primer espacio libre

entities_storage: .ds entities_storage_size ;;espacio

invalid_end_signal: .db e_type_invalid ;;final del array

num_entities:: .dw #0 ;;guardo 1 byt para contar 


man_entity_init::
    ld hl, #entities_storage ;;cojo el espacio
    ld (entities_1st_free), hl ;;cojo la direccion de donde empieza el array
    ld (hl), #0 ;; le meto un 0
    ret

man_entity_get_from_idx:: ;;le paso la posicion en DE entity en DEVUELVE IX y DE
    ld hl, #entities_1st_free
    inc hl
    inc hl
    ld ix,#entities_1st_free
    inc ix
    inc ix
    ld bc, #sizeof_e ;;pongo el tamano de entidad
    
    nepe:
        add hl, bc ;; lo sumo
        dec de
        add ix, bc

        ld a, e
        or a
        
    jr NZ, nepe
    ex de,hl
    
    ;;cuando la resta es 0 sale y 
    ;;devuelve la posicion de memoria donde empieza la entidad
    ret

man_entity_get_player:: ;;return donde empieza el player en IX
    ld ix, #entities_1st_free
    inc ix
    inc ix
ret

man_entity_create::
    push hl ;; 2 stack -> | hl | "ret" |
    ld hl, (entities_1st_free) ;;puntero a la primera libre
    ld d, h ;;preparo los valores
    ld e, l
    ld (hl), #e_type_default ;;pongo el primero a default 
    ld bc, #sizeof_e ;;pongo el tamano de entidad
    add hl, bc ;; lo sumo
    ld (entities_1st_free), hl
    pop hl ;; 1 stack -> | "ret" |
    ;;meto los valores 
    ldir ;;copia lo de HL en la posicion de DE, itera 1 en ambos tantas veces como en bc

    ;;Update number of entities

    push hl ;; 2 stack -> | hl | "ret" |
    ld hl,(num_entities)
    inc hl
    ld (num_entities), hl
    pop hl ;; 1 stack -> | "ret" 

    
    ;;ld (num_entities),a
    ret ;;DE = donde esta la entidad y BE = el tamaño

    ;;ldir = copia de hl a de perfecto para pintar

man_entity_destroy::
    ld a, #1
    ld (num_entities), a
    call man_entity_get_player
    ld bc, #sizeof_e
    add ix, bc
    ld (entities_1st_free), ix
    ret ;;DE = donde esta la entidad y BE = el tamaño

;;man_entity_set4destruction:: 

man_entity_destroy_all::
    ld a, #0
    ld (num_entities), a
    call man_entity_get_player
    ld (entities_1st_free), ix
    ret ;;DE = donde esta la entidad y BE = el tamaño

    
man_entity_forone_getX_getY:: ;; Get e_x & e_y of entity ix

    call man_entity_get_from_idx ;; ix -> entity to obtain e_x & e_y
     
    ld d,e_x(ix)
    ld e,e_y(ix)

ret
;;copiar forall para poner todo a 0 cuando quiera destruir entidad
man_entity_forall:: ;; Pos of Function to execute for all entities in hl
    call man_entity_get_player ;; inicializo ix a la primera entidad
    
    ld bc, (num_entities)
    push bc ;; 2 stacked (|num_entities|, |ret|)
    push hl ;; 3 stacked (|_function|, |num_entities|, |ret|)
    loop_render_ent:
    ld bc, #post_render_loop
    pop hl  ;; 2 stacked (|num_entities|, |ret|), _function in HL
    push bc ;; 3 stacked (|post_render_loop|, |num_entities|, |ret|)
    jp (hl) ;; call (_funcion) w/o modifying the stack
    post_render_loop:
    ld bc, #sizeof_e ;;
    add ix, bc       ;; Updating ix to the next entity
    pop hl           ;; 1 stack -> cont num_ent ; hl -> (_function)
    pop bc           ;; 0 stack  bc -> cont num_ent
    dec bc           ;; decrement num_ent until its 0
    push bc          ;
    push hl          ;; Re-Pushing all, 2 stack -> |(_function)|, |cont num_ent| ;
    ld a, c          ;; cont num_ent in a
    or a                    ;; if noZero, jump
    jr nz, loop_render_ent  ;
    pop hl           ;; resseting Stack
    pop hl           ;
ret

man_entity_update:: ;;copiado de otro sitio hacer a mano que no se como funciona
    ld ix, #entities_storage
    jr _nexte
_destroy_e:
    call man_entity_destroy
_nexte:
    ld a, e_type(ix)
    or a
    ret z
    and #e_type
    jr nz, _destroy_e
_dont_delete_e:
    ld bc, #sizeof_e
    add ix, bc
    jr _nexte