
;;SapphirePalace - Videogame
;;
   ;; Copyright (C) 2022 Jorge Lizón Perea, Angelica Quaranta Barba, Joan Pascual Izquierdo.
;;
   ;; This program is free software: you can redistribute it and/or modify
   ;; it under the terms of the GNU General Public License as published by
   ;; the Free Software Foundation, either version 3 of the License, or
   ;; (at your option) any later version.
;;
   ;; This program is distributed in the hope that it will be useful,
   ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
   ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ;; GNU General Public License for more details.
;;
   ;; You should have received a copy of the GNU General Public License
   ;; along with this program.  If not, see <https://www.gnu.org/licenses/>.
.module Colision_systems

.area _CODE

.include "cpctelera.h.s"
;;.include "cpctelera_funcs.inc"
.include "man/entities.inc"
.include "maps/mapa_uno.h.s"
.include "physics.inc"
.include "colisions.inc"
.include "render.inc"
.include "input.inc"
;.globl _current_level
;;player_Pos .db 00;
esquina_iz_sup:: .dw #0;
;;esquina_der_sup:: .dw #0;
;;esquina_der_inf:: .dw #0;
esquina_iz_inf:: .dw #0;
esquina_medio :: .dw #0

;;El player que esta siempre en la 0 es el que tiene colisiones
;;los enemigos van con patrones

;;required_cmps =(e_mask_alive | e_mask_physics) ;;mascara de alive y fisicas

sys_colision_update::
    
   ld hl, #_colision_one_entity
   call man_entity_forall
   ;;JUGADOR CON ENTIDADES
   call man_entity_get_player ;;ix la pos del player
    ld b,e_x(ix)
    ld c,e_y(ix)
    push bc
    
    ld hl,#1;; contador de las entidades
    
    ;;dec hl ;;Numentities -1 para tener bien el contador
    loopEnt: ;;Si hay una entidad en la misma pos X/Y que PLAYER
        
        push hl
        pop de
        push de
        call man_entity_forone_getX_getY ;;de = xy en pila el tipo
        pop hl
        pop bc
        jp comprobar_derecha
       
        ;;Contadores
        no_hay:
        inc hl
        ld a, (num_entities)
        sub l
        push bc
    jr NZ, loopEnt
    pop bc
    
   ret
    ;;lo pone a fondo 
    ;;ld hl,#0xC000
    ;;ld (hl),#0x00

comprobar_derecha:

    ld a,b
    add #3
    sub d
    ;; SI TIENE CARRY NO COLISIONA
    jp c, no_hay
    sub #3;;#16 ;;resto el tamaño de la entidad
    ;; SI HAY CARRY AQUI ESTA EN MEDIO, si no esta en la derecha 
    jp c, comprobar_abajo

comprobar_izquierda:
    
    ld a,d
    add #3
    sub b
    ;;SI HAY CARRY NO COLISIONA
    jp c, no_hay

comprobar_abajo:

    ;;Y
    ld a,c
    add #7
    sub e
    ;; si hay carry esta encima
    jp c, no_hay
    sub #7;;#16
    jp c, colisionSWITCH

comprobar_arriba:
    ld a,e
    add #7;;#16
    sub c
    ;;SI HAY CARRY ESTA DEBAJO
    jp c, no_hay


colisionSWITCH:

    ld a,e_type(ix)
    
    cp #2
    jr z, colisionENT

    cp #3
    jr z, colisionPUERTA
ret


colisionPUERTA::
    ;;destroy
    call man_entity_destroy
    call colisionENT
    call man_entity_get_player
    ld e_x(ix),#08
    ld e_y(ix),#75
    ld a, (_next_level)
    inc a
    ld (_next_level), a
    call cambio_mapa
    call render_tilemap_uno
    ;; reposicion del jugador
    
    ;; llamada para borrar entidades
    ;; y colocar las del siguiente mapa
ret

colisionENT:
        
        call man_entity_get_player
        ld de, #0xC000
        ;;Consigue la posición anterior en X e Y
        ld a, e_x(ix)
        sub e_vx(ix)
        ld c, a ;; c <- e_prevX
        ld a, e_y(ix)
        sub e_vy(ix)
        ld b, a ;; b <- e_prevY
        ;; Llamada para conseguir la posición en MemVideo
        call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
        ;; Borrado de Posicion Previa
        ex de, hl
        ld a, #12
        ld c, e_size_x(ix)
        ld b, e_size_y(ix)
        call cpct_drawSolidBox_asm
        call man_entity_get_player
        ld e_x(ix),#08
        ld e_y(ix),#75
        
ret
    

_colision_one_entity:
    
    call tile_player_sup_iz ;;resultado en IY
    ld a, #05
    cp (hl)
    jr nz, colision

    call tile_player_inf_iz
    ld a, #05
    cp (hl)
    jr nz, colision

    call tile_player_sup_der
    ld a, #05
    cp (hl)
    jr nz, colision

    call tile_player_inf_der
    ld a, #05
    cp (hl)
    jr nz, colision

    ld bc, #_colision_one_entity
    pop hl
    push bc
    jp(hl)
    ; call tile_player_inf_der_medio
    ; ld a, #05
    ; cp (hl)
    ; jr nz, colision

    ; call tile_player_sup_der_medio
    ; ld a, #05
    ; cp (hl)
    ; jr nz, colision

    ; call tile_player_inf_iz_medio
    ; ld a, #05
    ; cp (hl)
    ; jr nz, colision

    ; call tile_player_final_medio
    ; ld a, #05
    ; cp (hl)
    ; jr nz, colision

ret

colision:

    call undo_colision
    ld bc, #_colision_one_entity
    pop hl
    push bc
    jp(hl)
ret

tile_player_sup_iz: ;;calcula la posicion en tile del player RETURN IY
    
    ;;ESTO SOLO APUNTA A LA ESQUINA SUPERIOR IZQUIERDA
    ;;Calculo la entidad x/4
    ld a,e_x(ix) 
    srl a ;; a=e.(x)/2
    srl a ;; a=e.(x)/4
    ;;srl a ;; a=e.(x)/8
    ld c,a 
    ld b,#0 ;; bc=e.(x)/4
    ld a,e_y(ix) ;;a =e.y
    and #0b11111000 ;;a=8*(e.y/8)
    
    ld e,a ;;añadirmos 2 bits para las operaciones 0<y<160
    srl e ;;DE=4*init(e.y/8)
    ;;DE=4*init(e.y/8)
    ld d,b
    ld l,a
    ld h,d ;;lo pone a 0

    add hl,hl ;;hl=16*init(e.y/8)
    add hl,de ;;hl=20*init(e.y/8)
    add hl,bc ;; / hl=20*init(e.y/8) + (e.x/8)
    
    
    ex de,hl
    ;call set_nivel PARA PASARLE EL NIVEL ACTUAL??
    ld hl, (_current_level) ;;iy = direccion base
    add hl, de ;; iy = base + 20*init(e.y/8) + (e.x/4)
    ld (esquina_iz_sup), hl
ret

tile_player_inf_iz: ;;calcula la posicion en tile del player RETURN IY
    
    ;;ESTO SOLO APUNTA A LA ESQUINA inf IZQUIERDA
    ld hl ,(esquina_iz_sup)
    ld bc,#20 ;;el ancho de la tila para bajar 
    add hl, bc
    ld (esquina_iz_inf),hl
    
ret
    _inc_bc_y:
        ld bc, #40
        ret



tile_player_sup_der: ;;calcula la posicion en tile del player RETURN IY
    
    ld hl ,(esquina_iz_sup)
    inc hl
    
    
ret

tile_player_inf_der: ;;calcula la posicion en tile del player RETURN IY
    
   
   ld hl,(esquina_iz_inf)
   inc hl
   
ret

_inc_bc_x:
    inc hl
    ret


