
;;SapphirePalace - Videogame
;;
   ;; Copyright (C) 2022 Jorge Lizón Perea, Angelica Quaranta Barba, Joan Pascual Izquierdo.
;;
   ;; This program is free software: you can redistribute it and/or modify
   ;; it under the terms of the GNU General Public License as published by
   ;; the Free Software Foundation, either version 3 of the License, or
   ;; (at your option) any later version.
;;
   ;; This program is distributed in the hope that it will be useful,
   ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
   ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ;; GNU General Public License for more details.
;;
   ;; You should have received a copy of the GNU General Public License
   ;; along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "physics.inc"
.include "man/entities.inc"


border_r = 80
border_l = 254
border_d = 194
border_u = 254

sys_physics_update::
   ld hl, #_sys_update_one_entity
   call man_entity_forall
  ret
undo_colision::
   ld a, e_vx(ix)
   neg            ;; for the enemy to jump to the other direction when colliding with a wall 
   ld e_vx(ix), a ;;(because the player will reset his speed when input.s executes)
   
    ld a, e_x(ix) ;; /
    add e_vx(ix)  ;; |  Entity.x -= Entity.vx
    add e_vx(ix)  ;; \

    ld e_x(ix), a ;;inserted modified x
;
   ld a, e_vy(ix)
   neg            ;; the same that in the top
   ld e_vy(ix), a

    ld a, e_y(ix) ;; /
    add e_vy(ix)  ;; |  Entity.x -= Entity.vx
    add e_vy(ix)  ;; \
    ld e_y(ix), a ;;inserted modified y
  ret 


_sys_update_one_entity:
    ld a, e_x(ix)   ;; /
    add e_vx(ix)    ;; | Entity.x += Entity.vx
    ld e_x(ix), a   ;; \

    ld a, e_y(ix)   ;; /
    add e_vy(ix)    ;; | Entity.y += Entity.vy
    ld e_y(ix), a   ;; \
    ld bc, #_sys_update_one_entity
    pop hl
    push bc
    jp(hl)

