
;;SapphirePalace - Videogame
;;
   ;; Copyright (C) 2022 Jorge Lizón Perea, Angelica Quaranta Barba, Joan Pascual Izquierdo.
;;
   ;; This program is free software: you can redistribute it and/or modify
   ;; it under the terms of the GNU General Public License as published by
   ;; the Free Software Foundation, either version 3 of the License, or
   ;; (at your option) any later version.
;;
   ;; This program is distributed in the hope that it will be useful,
   ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
   ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   ;; GNU General Public License for more details.
;;
   ;; You should have received a copy of the GNU General Public License
   ;; along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "cpctelera.h.s"
.include "man/entities.inc"
.include "input.inc"
.include "render.inc"
.include "man/animations.inc"
.area _DATA
.area _CODE

v_start_clean:
   .db 0x01

;; init render (insert Pallete)
render_init::
   ld c, #0
   call cpct_setVideoMode_asm
   ld hl, #_fantasma_pal
   ld de, #16
   call cpct_setPalette_asm
ret
;;
;;pinto un mapa
;;
render_tilemap_uno:: ;; draw_map
   ld bc, #0x1414
   ld de, #20
   ld hl, #_tiles_00
   call cpct_etm_setDrawTilemap4x8_ag_asm

   ld hl, #CPCT_VMEM_START_ASM
   ld de, (_current_level)
   call cpct_etm_drawTilemap4x8_ag_asm

   ;call cambia_nivel_dos
ret

tile_draw_inicio:: ;; draw_map
   ld bc, #0x1414
   ld de, #20
   ld hl, #_tiles_00
   call cpct_etm_setDrawTilemap4x8_ag_asm

   ld hl, #CPCT_VMEM_START_ASM
   ld de, #_inicio_start
   call cpct_etm_drawTilemap4x8_ag_asm
ret

tile_draw_final:: ;; draw_map
   ld bc, #0x1414
   ld de, #20
   ld hl, #_tiles_00
   call cpct_etm_setDrawTilemap4x8_ag_asm

   ld hl, #CPCT_VMEM_START_ASM
   ld de, #_final
   call cpct_etm_drawTilemap4x8_ag_asm
ret
;############################################################
;#####              POSICIONES PUERTA                  ######
;############################################################


_borra_prev_pos:: ;; de-draw sprite in his prevPos

   ld de, #0xC000
   ;;Consigue la posición anterior en X e Y
   ld a, e_x(ix)
   sub e_vx(ix)
   ld c, a ;; c <- e_prevX
   ld a, e_y(ix)
   sub e_vy(ix)
   ld b, a ;; b <- e_prevY
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   ;; Borrado de Posicion Previa
   ex de, hl
   ld a, #12 ;;
   ld c, e_size_x(ix)
   ld b, e_size_y(ix)
   call cpct_drawSolidBox_asm
ret

_render_pinta_sprite:
   push hl ; 4 stack       | _sprite | (render_pinta_x) | post_render_loop | cont num_ent
   ;;                           1              2                 3
   ;; Pintar posicion actual
   ld de, #0xC000
   ld b, e_y(ix)
   ld c, e_x(ix)
   call cpct_getScreenPtr_asm
   ex de, hl 
   pop hl ; 3 stack -> | (render_pinta_x) | post_render_loop | cont num_ent
   ld c, e_size_x(ix)
   ld b, e_size_y(ix)
   call cpct_drawSprite_asm
   ld bc, #_switch_render
   pop hl ; 2 stack -> hl = (render_pinta_x), pila -> post_render_loop | cont num_ent
   pop hl ; 1 stack -> hl = post_render_loop,  | cont num_ent |
   push bc ; 2 stack -> (_switch_render), cont num_ent
   jp (hl)
ret

render_pinta_fantasma::
;;this is nothing
ret

sys_render_update::
   ld hl, #_switch_render
   call man_entity_forall
ret
_switch_render: ;; jump to his type of entity specifict render

   ld a, e_type(ix)
   cp #1
   jr z, _render_pinta_player
   
   cp #2
   jr z, _render_pinta_enemigo

   cp #3
   jr z, _render_pinta_puerta

ret

;;_render_pinta_enemigoGrande:
;;   call _borra_prev_pos
;;   ld hl, #_enemigo1_abre
;;   call _render_pinta_sprite
;;ret

_render_pinta_enemigo:
   call _borra_prev_pos
   ld a, (#_animation)
   or a
   jr nz, abre
   ld hl, #_enemigo1_cierra  ;; array of the sprite in hl
   call _render_pinta_sprite
   abre: 
      ld hl, #_enemigo1_abre ;; array of the sprite in hl
   call _render_pinta_sprite
ret

_render_pinta_puerta:
   call _borra_prev_pos
   ld hl, #_puerta           ;; array of the sprite in hl
   call _render_pinta_sprite 
ret

_render_pinta_player:
   call _borra_prev_pos
   ld hl, #_fantasma_array   ;; array of the sprite in hl
   call _render_pinta_sprite
ret


